package com.mojang.ld22.item.resource;

import com.mojang.ld22.entity.Player;
import com.mojang.ld22.level.Level;
import com.mojang.ld22.level.tile.Tile;

public class FoodResource extends Resource {
	private int heal;
	private int staminaCost;
	private int glow;

	public FoodResource(String name, int sprite, int color, int heal, int staminaCost, int glow) {
		super(name, sprite, color);
		this.heal = heal;
		this.staminaCost = staminaCost;
		this.glow = glow;
	}

	public boolean interactOn(Tile tile, Level level, int xt, int yt, Player player, int attackDir) {
		if (player.health < player.maxHealth && player.payStamina(staminaCost)) {
			player.heal(heal);
			player.personGlow = player.personGlow + glow;
			player.shroomAbuse = player.shroomAbuse + glow - 1;
			
			
			if (player.shroomAbuse > 20)
			{
				player.health = player.health -1;
				player.shroomAbuse = player.shroomAbuse -2;
			}
			
			return true;
		}
		return false;
	}
}
