package com.mojang.ld22.item.resource;

import com.mojang.ld22.entity.Player;
import com.mojang.ld22.gfx.Color;
import com.mojang.ld22.level.Level;
import com.mojang.ld22.level.tile.Tile;

public class Resource {
	public static Resource wood = new Resource("Wood", 1 + 4 * 32, Color.get(-1, 200, 531, 430));
	public static Resource stone = new Resource("Stone", 2 + 4 * 32, Color.get(-1, 111, 333, 555));
	public static Resource flower = new PlantableResource("Flower", 0 + 4 * 32, Color.get(-1, 10, 444, 330), Tile.flower, Tile.grass);
	public static Resource acorn = new PlantableResource("Acorn", 3 + 4 * 32, Color.get(-1, 100, 531, 320), Tile.treeSapling, Tile.grass);
	public static Resource dirt = new PlantableResource("Dirt", 2 + 4 * 32, Color.get(-1, 100, 322, 432), Tile.dirt, Tile.hole, Tile.water, Tile.lava);
	public static Resource sand = new PlantableResource("Sand", 2 + 4 * 32, Color.get(-1, 110, 440, 550), Tile.sand, Tile.grass, Tile.dirt);
	public static Resource cactusFlower = new PlantableResource("Cactus", 4 + 4 * 32, Color.get(-1, 10, 40, 50), Tile.cactusSapling, Tile.sand);
	public static Resource seeds = new PlantableResource("Seeds", 5 + 4 * 32, Color.get(-1, 10, 40, 50), Tile.wheat, Tile.farmland);
	public static Resource cone = new PlantableResource("Cone", 21 + 4 * 32, Color.get(-1, 200, 531, 43), Tile.bPine, Tile.grass, Tile.dirt);
	public static Resource seed = new PlantableResource("Seed", 15 + 4 * 32, Color.get(-1, 200, 531, 430), Tile.bElm, Tile.grass, Tile.dirt);
		
	public static Resource wheat = new Resource("Wheat", 6 + 4 * 32, Color.get(-1, 110, 330, 550));
	public static Resource bread = new FoodResource("Bread", 8 + 4 * 32, Color.get(-1, 110, 330, 550), 2, 5, 0);
	public static Resource apple = new FoodResource("Apple", 9 + 4 * 32, Color.get(-1, 100, 300, 500), 1, 5, 0);
	public static Resource fish = new FoodResource("Fish", 14 + 4 * 32, Color.get(-1, 101, 404, 545), 4, 5, 0);
	public static Resource meat = new FoodResource("Meat", 15 + 4 * 32, Color.get(-1, 100, 300, 500), 3, 5, 0);
	public static Resource mango = new FoodResource("Mango", 9 + 4 * 32, Color.get(-1, 110, 330, 550), 2, 6, 0);
	public static Resource cherry = new FoodResource("Cherry", 15 + 4 * 32, Color.get(-1, 311, 511, 411), 1, 1, 0);
	public static Resource pinon = new FoodResource("Pinon", 15 + 4 * 32, Color.get(-1, 110, 330, 430), 1, 1, 0);
	public static Resource fungus = new FoodResource("Fungus", 20 + 4 * 32, Color.get(-1, 10, 40, 50), 0, 5, 2);
	// public static Resource nut = new FoodResource("Nut", 15 + 4 * 32, Color.get(-1, 200, 531, 430), 1, 7, 0);
	
// public static Resource meat = new FoodResource("Meat", Column of Graphic + 4 * 32, Color.get(-1, 100, 300, 500), Food Value, 5);

	
	public static Resource coal = new Resource("COAL", 10 + 4 * 32, Color.get(-1, 000, 111, 111));
	public static Resource ironOre = new Resource("I.ORE", 10 + 4 * 32, Color.get(-1, 100, 322, 544));
	public static Resource goldOre = new Resource("G.ORE", 10 + 4 * 32, Color.get(-1, 110, 440, 553));
	public static Resource ironIngot = new Resource("IRON", 11 + 4 * 32, Color.get(-1, 100, 322, 544));
    public static Resource goldIngot = new Resource("GOLD", 11 + 4 * 32, Color.get(-1, 110, 330, 553));
    

	public static Resource slime = new Resource("SLIME", 10 + 4 * 32, Color.get(-1, 10, 30, 50));
	public static Resource glass = new Resource("glass", 12 + 4 * 32, Color.get(-1, 555, 555, 555));
	//I changed cloth to a plantable resource and made it turn water into rock.  This was done for no good reason.
	public static Resource cloth = new PlantableResource("cloth", 1 + 4 * 32, Color.get(-1, 25, 252, 141),Tile.rock, Tile.water);
	public static Resource cloud = new PlantableResource("cloud", 2 + 4 * 32, Color.get(-1, 222, 555, 444), Tile.cloud, Tile.infiniteFall);
	// I changed the gem from Resource to Plantable Resource and add the code to make it fill holes with rock.
	public static Resource gem = new PlantableResource("gem", 13 + 4 * 32, Color.get(-1, 101, 404, 545),Tile.rock, Tile.hole);
	public static Resource boxium = new Resource("Boxium", 2 + 4 * 32, Color.get(-1, 101, 323, 535));
	public final String name;
	public final int sprite;
	public final int color;

	public Resource(String name, int sprite, int color) {
		if (name.length() > 6) throw new RuntimeException("Name cannot be longer than six characters!");
		this.name = name;
		this.sprite = sprite;
		this.color = color;
	}

	public boolean interactOn(Tile tile, Level level, int xt, int yt, Player player, int attackDir) {
		return false;
	}
}